<template>
  <div id="app" class="App" :class="isIOS && 'is-ios'">
    <ion-app>
      <ion-content>
        <refresh-app-alert />
        <app-header v-show="showHeader" />
        <app-sidebar v-if="showSidebar" />
        <app-modal v-if="showModal" />
        <app-banner v-if="showBanner" />
        <div
          :class="{
            'App-router-view-wrapper': true,
            'App-router-view-wrapper--header': showHeader,
            'App-router-view-wrapper--sidebar': showSidebar,
          }"
        >
          <attention-boxes v-if="showInAppSessionNotifications" />
          <router-view />
        </div>
      </ion-content>
    </ion-app>
  </div>
</template>

<script>
import { mapState, mapGetters } from 'vuex'
import { IonApp, IonContent } from '@ionic/vue'
import Gleap from 'gleap'
import posthog from 'posthog-js'
import '@/scss/main.scss'
import AppHeader from './AppHeader/index.vue'
import AppSidebar from './AppSidebar/index.vue'
import AppModal from './AppModal/index.vue'
import AppBanner from './AppBanner/index.vue'
import PortalService from '@/services/PortalService'
import getOperatingSystem from '@/utils/get-operating-system'
import isOutdatedMobileAppVersion from '@/utils/is-outdated-mobile-app-version'
import AnalyticsService from '@/services/AnalyticsService'
import FeatureFlagService from '@/services/FeatureFlagService'
import LoggerService from '@/services/LoggerService'
import AttentionBoxes from '../AttentionBoxes.vue'
import { socket } from '@/socket'
import sound from '@/assets/audio/alert.mp3'
import RefreshAppAlert from '@/views/RefreshAppAlert.vue'

export default {
  name: 'App',
  components: {
    RefreshAppAlert,
    AppHeader,
    AppSidebar,
    AppModal,
    AppBanner,
    AttentionBoxes,
    IonApp,
    IonContent,
  },
  data() {
    return {
      audioAlert: new Audio(sound),
      isIOS: false,
      docHiddenProperty: '',
      checkForUpdateIntervalId: null,
    }
  },
  async created() {
    // Listen for resize event
    window.addEventListener('resize', this.handleResize)
    this.handleResize()
    await this.$store.dispatch('app/checkEnvironment', this)
    PortalService.call('app.isLoaded')

    this.setVisibilityListener()

    if (this.isMobileApp) {
      document.addEventListener('click', this.handleExternalURLs, false)

      if (isOutdatedMobileAppVersion()) {
        // show modal after children components have mounted
        setTimeout(() => {
          this.$store.dispatch('app/modal/show', {
            component: 'UpgradeAppModal',
            data: {
              showTemplateButtons: false,
            },
          })
        }, 1000)
      }

      if (getOperatingSystem() === 'iOS') {
        this.isIOS = true
        document.addEventListener('click', this.iOSFocusElements, false)
      }
    }
  },
  mounted() {
    if (this.mobileMode) {
      Gleap.hide()
    }
    this.$store.commit(
      'volunteer/setNewWaitingStudentAudioElement',
      this.audioAlert
    )
  },
  beforeUnmount() {
    window.removeEventListener('resize', this.handleResize)
    clearInterval(this.checkForUpdateIntervalId)

    if (this.isMobileApp) {
      document.removeEventListener('click', this.handleExternalURLs)

      if (getOperatingSystem() === 'iOS') {
        document.addEventListener('click', this.iOSFocusElements, false)
      }
    }
  },
  methods: {
    iOSFocusElements(e) {
      if (!e) {
        return
      }
      const focusTags = ['INPUT', 'TEXTAREA', 'SELECT']
      const focusTag = document.activeElement.tagName
      if (
        focusTags.indexOf(focusTag) !== -1 &&
        focusTags.indexOf(e.target.tagName) === -1
      ) {
        return document.activeElement.blur()
      }
    },
    handleResize() {
      this.$store.dispatch('app/windowResize', {
        width: window.innerWidth,
        height: window.innerHeight,
      })
    },
    handleExternalURLs(event) {
      const isATag = event.target.tagName.toLowerCase() === 'a'
      const isSameHost = window.location.hostname === event.target.hostname
      const mailToLinkPattern = /^mailto:/i

      // Open native mobile browser or email if the a tag has a different host or
      // if the a tag has "mailto" in its href
      if (
        isATag &&
        (!isSameHost || mailToLinkPattern.test(event.srcElement.href))
      ) {
        const { href } = event.target
        PortalService.call('browser.openWindow', {
          url: href,
          target: '_system',
        })
      }
    },
    setVisibilityListener() {
      let visibilityChange
      // Opera 12.10 and Firefox 18 and later support
      if (typeof document.hidden !== 'undefined') {
        this.docHiddenProperty = 'hidden'
        visibilityChange = 'visibilitychange'
      } else if (typeof document.msHidden !== 'undefined') {
        this.docHiddenProperty = 'msHidden'
        visibilityChange = 'msvisibilitychange'
      } else if (typeof document.webkitHidden !== 'undefined') {
        this.docHiddenProperty = 'webkitHidden'
        visibilityChange = 'webkitvisibilitychange'
      }

      document.addEventListener(visibilityChange, this.handleVisibilityChange)
    },
    async handleVisibilityChange() {
      await this.$store.dispatch(
        'app/updateWebPageVisibility',
        this.docHiddenProperty
      )
    },
    emitList({ retryCount = 0, maxRetries = 5 }) {
      let isAcknowledged = false
      let timeoutId
      socket.emit('list', null, (response) => {
        if (response.status === 200) {
          isAcknowledged = true
          clearTimeout(timeoutId)
          this.$store.dispatch('volunteer/handleIncomingSessions', {
            context: this,
            sessions: response.sessions,
          })
        }
      })

      if (retryCount < maxRetries) {
        // simple exponential backoff
        const delay = Math.pow(2, retryCount) * 500
        timeoutId = setTimeout(() => {
          if (!isAcknowledged) {
            this.emitList({
              retryCount: retryCount + 1,
              maxRetries,
            })
          }
        }, delay)
      } else {
        LoggerService.noticeError(
          `Max retry attempts reached, unable to fetch list of sessions for user: ${this.user.id}`
        )
      }
    },
  },
  computed: {
    ...mapState({
      showHeader: (state) => state.app.header.isShown,
      showSidebar: (state) => state.app.sidebar.isShown,
      showModal: (state) => state.app.modal.isShown,
      showBanner: (state) => state.app.banner.isShown,
      bannerComponent: (state) => state.app.banner.component,
      isMobileApp: (state) => state.app.isMobileApp,
      isWebPageHidden: (state) => state.app.isWebPageHidden,
      user: (state) => state.user.user,
      session: (state) => state.user.session,
      subjects: (state) => state.subjects.subjects,
      topics: (state) => state.subjects.topics,
      productFlags: (state) => state.productFlags.flags,
      isConnected: (state) => state.socket.isConnected,
    }),
    ...mapGetters({
      userAuthenticated: 'user/isAuthenticated',
      mobileMode: 'app/mobileMode',
      isVolunteer: 'user/isVolunteer',
      isStudent: 'user/isStudent',
      isTeacher: 'user/isTeacher',
      isAutoFlowUser: 'user/isAutoFlowUser',
      getUserPropsForAnalytics: 'user/getUserPropsForAnalytics',
      showInAppSessionNotifications:
        'featureFlags/showInAppSessionNotifications',
    }),
    isSocketReadyToGetWaitingStudents() {
      return [this.isConnected, this.isVolunteer]
    },
  },
  watch: {
    async user(currentUserValue, previousUserValue) {
      const nowLoggedIn = currentUserValue.id && !previousUserValue.id
      if (nowLoggedIn) {
        if (!this.$store.state.socket.isConnected) {
          this.$store.dispatch('socket/connect')
        }

        await this.$store.dispatch('productFlags/getUserProductFlags')
        const userProps = this.getUserPropsForAnalytics()
        AnalyticsService.identify(currentUserValue.id, userProps)
        LoggerService.identify(currentUserValue.id)
        FeatureFlagService.setPersonPropertiesForFlags(userProps)

        if (this.mobileMode && !this.isMobileApp && this.isStudent) {
          this.$store.dispatch('app/banner/show', {
            component: 'MobileAppNoticeBanner',
          })
        }

        if (this.isStudent) {
          this.$store.dispatch('session/fetchLatestSession')
        }

        if (Object.entries(this.subjects).length === 0)
          this.$store.dispatch('subjects/getSubjects')

        if (!this.topics.length) {
          this.$store.dispatch('subjects/getTopics')
        }

        this.$store.dispatch('user/getProgressReportOverviewSubjectStats')
      } else if (currentUserValue.id) {
        const userProps = this.getUserPropsForAnalytics()
        AnalyticsService.updateUser(userProps)
      }
    },
    /**
     * This is a workaround for MobileAppNoticeBanner.vue not properly watching "mobileMode".
     * Hides the MobileAppNoticeBanner if not in mobile mode
     */
    mobileMode(isMobileMode) {
      if (!isMobileMode && this.bannerComponent === 'MobileAppNoticeBanner')
        this.$store.dispatch('app/banner/hide')
    },

    /**
     * On route transition, fetch current session.
     * @todo: Fetch these much less frequently (only once).
     * @todo: Consolidate with the logic in router.
     * @todo: Consolidate with latestSession.
     */
    $route(to, from) {
      // Capture PostHog pageviews on route transitions
      if (to.path !== from.path) posthog.capture('$pageview')
      if (to.path !== '/logout' && this.userAuthenticated) {
        if (!this.isTeacher) {
          this.$store.dispatch('user/fetchSession', this)
        }
      }
    },
    isAutoFlowUser(currentValue, prevValue) {
      if (currentValue && !prevValue) this.$router.push('/welcome')
    },
    session(currentValue, prevValue) {
      const hadASession = !currentValue.id && prevValue.id
      if (hadASession) {
        this.$store.dispatch('user/updateHadASession', true)
        this.$store.dispatch(
          'user/updatePrevSessionSubject',
          prevValue.subTopic
        )
      }
    },
    isSocketReadyToGetWaitingStudents(currentVal) {
      const [isConnected, isVolunteer] = currentVal
      if (isConnected && isVolunteer) {
        this.emitList({ retryCount: 0, maxRetries: 5 })
      }
    },
  },
}
</script>

<style lang="scss">
%LargeButton {
  border: 1px solid rgba(0, 0, 0, 0); // for consistent button size
  border-radius: 20px;
  padding: 9px 23px; // subtracted 1px for border
  display: inline-flex;
}
</style>

<style lang="scss" scoped>
ion-content {
  --background: transparent;
  font-family: $font-family-default;
}

.App {
  height: 100%;
}

.is-ios {
  position: fixed;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  overflow: auto;

  @media only screen and (orientation: landscape) {
    min-height: initial;
  }
}

.App-router-view-wrapper {
  height: 100%;

  &--header {
    @include bind-app-header-height(padding-top);
  }

  &--sidebar {
    @include bind-app-sidebar-width(padding-left);
    padding-left: 0;
  }
}
</style>
